%%
%% abstract.tex
%%
%% Abstract for diploma thesis
%% Marcel Baur <mbaur@iiic.ethz.ch>
%%
%% $Id: abstract.tex,v 1.15 2003-03-08 10:54:56 baurma Exp $
%% $Revision: 1.15 $
%%

\begin{myabstract}

%% \addcontentsline{toc}{chapter}{Abstract}
\pdfbookmark[0]{Abstract}{myabstract}

Replay of program executions, that lead to a failure, can help
developers to find software faults. While replay of deterministic
executions of sequential programs can be easily achieved with
existing debuggers, little support exists for deterministic replay
of a multi-threaded program.

In Java, scheduling of threads depends on the algorithm implemented 
in the underlying virtual machine. A multi-threaded program is
executed according to one of many possible schedules.

In this thesis a conceptual model to replay a specific thread schedule
of a multi-threaded Java program is developed. A generic representation
of an execution trace that contains all information for a
deterministic replay of a given thread schedule was devised. Deterministic 
replay is achieved by modifying the bytecode of the original program such 
that only one thread at a time may runs according to the specified schedule. 
This allows deterministic replay on any virtual machine that conforms to the 
specification by Sun.

The model is implemented in \textbf{jreplay}, a software utility to enforce 
a given thread schedule in a compiled Java program. The application is
implemented within the \JNuke framework for checking Java bytecode.
For this purpose, the framework was extended with a class writer and 
a bytecode instrumentation facility.

A number of experiments have been performed to validate the model and
measure its efficiency.

\end{myabstract}
